//////////////////////////////////////////////////////////////
//                                                          //
//   map.cpp   - an expandable array for key-value relations//
//   v1.0                                                   //
//               implementations                            //
//                                                          //
//   Language     : Borland C++                             //
//   System       : MS-DOS 6.2,  Windows 95 v4.400.950      //
//   Application  : CSE 687 pr2-shall                       //
//   Author       : Mehmet SEN                              //
//   Date         : /2/19/1997                              //
//              copyright (c) 1997                          //
//          all the rights you can think of.                //
//             have fun.                                    //
//                                                          //
//////////////////////////////////////////////////////////////



#include <iostream.h>
#include <stdlib.h>
#include <conio.h>              //getch for waiting user getch
#include "map.hpp"
#ifdef TEST_MAP_FILES           // SPECIAL test with files in current dir.
#include <dir.h>                // files reading
#include <stdio.h>        //sprintf()
#endif

#ifdef TEST_MAP    // general map test is asked
// wait for the key pressed.
void confirm(){
  cout  << "/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/"<<endl
	<<"HERE is the results"<<endl
	<< "/_/_/_/_/_/_/_/_/_/_/_/_/, press any key..."<<endl;
  getch();
}

// test the map class by using string classes
void general_map_test()
{
  map<cmpStr,int> grades("mehmet",100);     // construct a new map
  cout << "Map,grades, is constructed with 10 locations and initial value "<<endl
	<< "mehmet --> 100"<<endl;
  cmpStr key("Mustafa");                   // insertion
  int val=99;
  cout << "Mustafa --> 99 will be inserted"<<endl;
  grades.insert(key,val);
  key="";
  cout << "Also, it will insert 13 association e-strings"<<endl;
  for (int i=0;i<13;i++){
	val=i;
	key+="e";
	grades.insert(key,val);
  }
  confirm();
  grades.dump(cout);                        //assignments
  cout <<endl<<endl<< "NEXT:Assignments as following "<<endl
       << "	mehmet  <------- 98"  <<endl
       << "	Mustafa <--------94" <<endl
       << "     eeeee   <--------100"<<endl
       << "     eeeeeeeeee<------[eeeee]"<<endl;
  grades["eeeee"]=100;
  grades["eeeeeeeeee"]=grades["eeeee"];
  grades["mehmet"]=98;
  grades["Mustafa"]=94;
  confirm();
  grades.dump(cout);
}
#endif
#ifdef TEST_MAP_FILES   // map test with files asked
/// list the files in current directory in sorted order using map classes
void files_map_test(){
	map<cmpStr,str> files(100);
	struct ffblk ffblk;
	int hour,min,sec;
	int year, mon, day;
	char fdata[100];
	int done = findfirst("*.*",&ffblk,0);
	while (!done)	{
	      hour= ffblk.ff_ftime >>11;           // get time
	      min= (ffblk.ff_ftime >>5) & 63;
	      sec= ffblk.ff_ftime & 31;
	      year=(ffblk.ff_fdate>>9) +1980;     // get date
	      mon=  (ffblk.ff_fdate>>5) & 15;
	      day=ffblk.ff_fdate & 31;
	      sprintf(fdata,"       %ld bytes   %d/%d/%d   %d:%d:%d",
			ffblk.ff_fsize,	mon,day,year,hour,min,sec);
	      files.insert(ffblk.ff_name,fdata);
	      done = findnext(&ffblk);
   }
   cout <<"Directory listing of *.*\n";
   files.dump(cout);
}
#endif
//////////////////////////////////////////////////////////////////
// MAIN FUNCTION DEFINITIONS
//////////////////////////////////////////////////////////////////
#ifdef TEST_MAP_FILES              // has priority over TEST_MAP
				// if both defined
void main(){
	files_map_test();
}
#elif defined TEST_MAP
void main(){
	general_map_test();
}
#endif

