#ifndef TMOUSE_HPP
#define TMOUSE_HPP

///////////////////////////////////////////////////////////////
//                                                           //
//  tmouse.hpp - tiny text mouse class                       //
//  v1.0                                                     //
//                                                           //
///////////////////////////////////////////////////////////////
//                                                           //
//  manual page                                              //
//                                                           //
//  Language:    Borland C, ver 3.1;                         //
//  Platform:    Gateway 386/25, win95                       //
//  Application: CSE687, pr3                                 //
//  Author:      Jim Fawcett, 123 Link Hall, Syracuse Univ   //
//               Syracuse, N.Y., 13244, (315)443-2654        //
//                                                           //
//           copyright (c) 1996, James W. Fawcett            //
//                all rights granted to user                 //
//                    except publication                     //
//                                                           //
///////////////////////////////////////////////////////////////
/*
  tmouse class operations:
  ========================

  construct and manage mouse object:
  ==================================
    tmouse();            construct mouse object
    int installed();     is mouse driver installed?
    void hide();         hide mouse cursor
    void show();         show mouse cursor

  get mouse data:
  ===============
    int wherex();        return mouse column
    int wherey();        return mouse row
    int lftDn();         is left button down?
    int rgtDn();         is right button down?

*/

//


///////////////////////////////////////////////////////////////
//                                                           //
//  maintenance page                                         //
//                                                           //
///////////////////////////////////////////////////////////////
//                                                           //
//  Build Process                                            //
//                                                           //
//  Files Required:                                          //
//    tmouse.hpp, tmouse.cpp                                 //
//                                                           //
//  Command Line Compiler Build:                             //
//    tcc -w+ -DTEST_TMOUSE tmouse.cpp                       //
//                                                           //
//  Integrated Environment Build:                            //
//    - close any open project                               //
//    - set Options/Compiler/Code generation/defines to      //
//      TEST_TMOUSE                                          //
//    - run                                                  //
//                                                           //
///////////////////////////////////////////////////////////////
/*

    Maintenance History:
    ====================
    ver 1.0 : 17 Apr 96
      - first release

    Planned Modifications:
    ======================
      - is point in mouse neigborhood?
      - was mouse button released since last event?
*/

//

enum buttonState { up, down };

class tmouse {

  public:
    tmouse();
    int installed();
    void hide();
    void show();
    int wherex();
    int wherey();
    int lftDn();
    int rgtDn();
    int lftUp();
    int rgtUp();

  private:
    buttonState left, right;
    int lastRow, lastCol;
};

#endif

